<template>
  <div class="app-container">
    <el-form v-show="showSearch" ref="queryRef" :model="queryParams" :inline="true" label-width="68px">
      <el-form-item label="任务名称" prop="jobName">
        <el-input v-model="queryParams.jobName" placeholder="请输入任务名称" clearable @keyup.enter="handleQuery" />
      </el-form-item>
      <el-form-item label="执行状态" prop="status">
        <el-select v-model="queryParams.status" placeholder="请选择执行状态" clearable>
          <el-option
            v-for="dict in sys_success_fail"
            :key="dict.value"
            :label="dict.label"
            :value="dict.value"
          />
        </el-select>
      </el-form-item>
      <el-form-item label="执行时间" style="width: 308px">
        <el-date-picker
          v-model="dateRange"
          value-format="YYYY-MM-DD HH:mm:ss"
          type="daterange"
          range-separator="-"
          start-placeholder="开始日期"
          end-placeholder="结束日期"
          :default-time="[new Date(2000, 1, 1, 0, 0, 0), new Date(2000, 1, 1, 23, 59, 59)]"
        />
      </el-form-item>
      <el-form-item>
        <el-button type="primary" icon="Search" @click="handleQuery">搜索</el-button>
        <el-button icon="Refresh" @click="resetQuery">重置</el-button>
      </el-form-item>
    </el-form>

    <el-row :gutter="10" class="mb8">
      <el-col :span="1.5">
        <el-button
          v-has-permi="['tool:job:remove']"
          type="danger"
          icon="Delete"
          plain
          :disabled="multiple"
          @click="handleDelete"
        >删除</el-button>
      </el-col>
      <el-col :span="1.5">
        <el-button
          v-has-permi="['tool:job:remove']"
          type="danger"
          icon="Delete"
          plain
          @click="handleClean"
        >清空</el-button>
      </el-col>
      <el-col :span="1.5">
        <el-button
          v-has-permi="['tool:job:export']"
          type="warning"
          icon="Download"
          plain
          @click="handleExport"
        >导出</el-button>
      </el-col>
      <el-col :span="1.5">
        <el-button
          type="warning"
          icon="Close"
          plain
          @click="handleClose"
        >关闭</el-button>
      </el-col>
      <right-toolbar v-model:show-search="showSearch" @query-table="getList" />
    </el-row>

    <el-table v-loading="loading" :data="jobLogList" @selection-change="handleSelectionChange">
      <el-table-column type="selection" width="55" align="center" />
      <el-table-column label="日志编号" width="80" align="center" prop="jobLogId" />
      <el-table-column label="任务名称" align="center" prop="jobName" min-width="130" :show-overflow-tooltip="true" />
      <!-- <el-table-column label="任务组名" align="center" prop="jobGroup" :show-overflow-tooltip="true" /> -->
      <el-table-column label="cron执行表达式" align="center" prop="cronExpression" :show-overflow-tooltip="true" />
      <el-table-column label="执行状态" align="center" prop="status">
        <template #default="scope">
          <dict-tag :options="sys_success_fail" :value="scope.row.status" />
        </template>
      </el-table-column>
      <el-table-column label="消耗时间(毫秒)" align="center" prop="costTime" />
      <!-- <el-table-column label="日志信息" align="center" prop="jobMessage" :show-overflow-tooltip="true" /> -->
      <el-table-column label="执行时间" align="center" prop="createTime" width="180">
        <template #default="scope">
          <span>{{ $parseTime(scope.row.createTime) }}</span>
        </template>
      </el-table-column>
      <el-table-column label="操作" align="center" class-name="small-padding fixed-width">
        <template #default="scope">
          <el-button
            v-has-permi="['tool:job:query']"
            type="primary"
            icon="View"
            link
            @click="handleView(scope.row)"
          >详细</el-button>
          <el-button
            v-has-permi="['tool:job:remove']"
            type="danger"
            icon="Delete"
            link
            @click="handleDelete(scope.row)"
          >删除</el-button>
        </template>
      </el-table-column>
    </el-table>

    <pagination
      v-show="total > 0"
      v-model:page="queryParams.pageNumber"
      v-model:limit="queryParams.pageSize"
      :total="total"
      @pagination="getList"
    />

    <!-- 调度日志详细 -->
    <el-dialog v-model="open" title="调度日志详细" width="700px" append-to-body>
      <el-form :model="form" label-width="130px">
        <el-row>
          <el-col :span="24">
            <el-form-item label="任务名称：">{{ form.jobName }}</el-form-item>
          </el-col>
          <el-col :span="12">
            <el-form-item label="日志编号：">{{ form.jobLogId }}</el-form-item>
          </el-col>
          <el-col :span="12">
            <el-form-item label="任务分组：">{{ form.jobGroup }}</el-form-item>
          </el-col>
          <el-col :span="12">
            <el-form-item label="cron执行表达式：">{{ form.cronExpression }}</el-form-item>
          </el-col>
          <el-col :span="12">
            <el-form-item label="消耗时间(毫秒)：">{{ form.costTime }}</el-form-item>
          </el-col>
          <el-col :span="24">
            <el-form-item label="执行时间：">{{ form.createTime }}</el-form-item>
          </el-col>
          <el-col :span="24">
            <el-form-item label="日志信息：">{{ form.jobMessage }}</el-form-item>
          </el-col>
          <el-col :span="24">
            <el-form-item label="执行状态：">{{ statusFormat(form) }}</el-form-item>
          </el-col>
          <el-col :span="24">
            <el-form-item v-if="form.status == '1'" label="异常信息：">{{ form.exceptionInfo }}</el-form-item>
          </el-col>
        </el-row>
      </el-form>
      <template #footer>
        <div class="dialog-footer">
          <el-button @click="open = false">关 闭</el-button>
        </div>
      </template>
    </el-dialog>
  </div>
</template>

<script name="JobLog" setup>
import { listJobLog, delJobLog, cleanJobLog } from '@/api/tool/jobLog'

const { proxy } = getCurrentInstance()
const { sys_success_fail } = proxy.$useDict('sys_success_fail')

const jobLogList = ref([])
const open = ref(false)
const loading = ref(true)
const showSearch = ref(true)
const ids = ref([])
const multiple = ref(true)
const total = ref(0)
const dateRange = ref([])
const route = useRoute()

const data = reactive({
  form: {},
  queryParams: {
    pageNumber: 1,
    pageSize: 10,
    jobName: undefined,
    jobGroup: undefined,
    status: undefined,
    startTime: undefined,
    endTime: undefined
  }
})

const { queryParams, form } = toRefs(data)

/** 查询调度日志列表 */
function getList() {
  loading.value = true
  listJobLog(proxy.$addDateRange(queryParams.value, dateRange.value)).then(res => {
    jobLogList.value = res.list
    total.value = Number(res.total)
    loading.value = false
  })
}

/** 状态字典翻译 */
function statusFormat(row, column) {
  return proxy.$selectDictLabel(sys_success_fail.value, row.status)
}

// 返回按钮
function handleClose() {
  const obj = { path: '/tool/job' }
  proxy.$tab.closeOpenPage(obj)
}

/** 搜索按钮操作 */
function handleQuery() {
  queryParams.value.pageNumber = 1
  getList()
}

/** 重置按钮操作 */
function resetQuery() {
  dateRange.value = []
  proxy.$resetForm('queryRef')
  handleQuery()
}

// 多选框选中数据
function handleSelectionChange(selection) {
  ids.value = selection.map(item => item.jobLogId)
  multiple.value = !selection.length
}

/** 详细按钮操作 */
function handleView(row) {
  open.value = true
  form.value = row
}

/** 删除按钮操作 */
function handleDelete(row) {
  const jobLogIds = row.jobLogId || ids.value
  proxy.$modal.confirm('是否确认删除调度日志编号为 "' + jobLogIds + '" 的数据项?').then(function() {
    return delJobLog(jobLogIds)
  }).then(() => {
    getList()
    proxy.$modal.msgSuccess('删除成功')
  }).catch(() => {})
}

/** 清空按钮操作 */
function handleClean() {
  proxy.$modal.confirm('是否确认清空所有调度日志数据项?').then(function() {
    return cleanJobLog()
  }).then(() => {
    getList()
    proxy.$modal.msgSuccess('清空成功')
  }).catch(() => {})
}

/** 导出按钮操作 */
function handleExport() {
  proxy.$download('tool/jobLog/export', {
    ...queryParams.value
  }, `job_log_${new Date().getTime()}.xls`)
}

(() => {
  const jobName = route.params && route.params.jobName
  if (jobName) {
    queryParams.value.jobName = jobName
  }
  getList()
})()
</script>
